"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
exports.__esModule = true;
exports.Storage = void 0;
var value_1 = require("../value");
var utils_1 = require("../utils");
var iterators_1 = require("../iterators");
/**
 * Key-value storage.
 */
var Storage = /** @class */ (function (_super) {
    __extends(Storage, _super);
    function Storage(params, parentPaths) {
        if (params === void 0) { params = utils_1.EMPTY_OBJECT; }
        if (parentPaths === void 0) { parentPaths = iterators_1.EMPTY_ITER; }
        var _this = _super.call(this) || this;
        _this.params = params;
        _this.parentPaths = parentPaths;
        _this.destroyed = false;
        if (_this.params.onCreateStorage != null)
            _this.params.onCreateStorage(_this);
        return _this;
    }
    /**
     * Calls a `destroy` implementation that will unlink given storage from all entities
     * referencing it.
     *
     */
    Storage.prototype.destroy = function () {
        var e_1, _a;
        if (this.destroyed)
            return;
        this.destroyed = true;
        try {
            for (var _b = __values(this.parentPaths), _c = _b.next(); !_c.done; _c = _b.next()) {
                var path = _c.value;
                path.drop(this);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b["return"])) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (this.params.onRemoveStorage != null)
            this.params.onRemoveStorage(this);
    };
    /**
     * Returns `true` if supplied is weak, and thus won't be stored directly.
     * @param key
     */
    Storage.prototype.isWeak = function (_key) {
        return false;
    };
    /**
     * Returns `true` if value associated with the given key exists.
     * @param key
     *
     */
    Storage.prototype.has = function (key) {
        return this.get(key) !== value_1.NO_VALUE;
    };
    return Storage;
}(utils_1.HasLength));
exports.Storage = Storage;
//# sourceMappingURL=Storage.js.map