"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
exports.Single = void 0;
var iterators_1 = require("../iterators");
var value_1 = require("../value");
var types_1 = require("./types");
/**
 * Wrapper class which represents ordered indexed collection with a single item.
 */
var Single = /** @class */ (function (_super) {
    __extends(Single, _super);
    function Single(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    Single.prototype.pushFront = function (value) {
        if (this.isEmpty()) {
            return (this.value = value);
        }
        else {
            return value_1.NO_VALUE;
        }
    };
    Single.prototype.pushBack = function (value) {
        return this.pushFront(value);
    };
    Single.prototype.takeKeyFront = function () {
        return this.takeFront();
    };
    Single.prototype.takeKeyBack = function () {
        return this.takeFront();
    };
    Single.prototype.peekKeyFront = function () {
        return this.peekFront();
    };
    Single.prototype.peekKeyBack = function () {
        return this.peekBack();
    };
    Single.prototype.addKeyFront = function (_key, _item) {
        return false;
    };
    Single.prototype.addKeyBack = function (_key, _item) {
        return false;
    };
    Single.prototype.dropKey = function (value) {
        if (this.has(value)) {
            this.takeFront();
            return true;
        }
        else {
            return false;
        }
    };
    Single.prototype.get = function (value) {
        return this.has(value) ? this.value : value_1.NO_VALUE;
    };
    Single.prototype.keysFront = function () {
        return this.valuesFront();
    };
    Single.prototype.keysBack = function () {
        return this.valuesBack();
    };
    Single.prototype.takeFront = function () {
        var value = this.value;
        this.value = value_1.NO_VALUE;
        return value;
    };
    Single.prototype.takeBack = function () {
        return this.takeFront();
    };
    Single.prototype.insertAfter = function (_element, _value) {
        return value_1.NO_VALUE;
    };
    Single.prototype.insertBefore = function (_element, _value) {
        return value_1.NO_VALUE;
    };
    Single.prototype.contains = function (element) {
        return (0, value_1.equals)(element, this.value);
    };
    Single.prototype.has = function (value) {
        return (0, value_1.equals)(value, this.value);
    };
    Single.prototype.drop = function (value) {
        return this.has(value) ? this.takeFront() : value_1.NO_VALUE;
    };
    Single.prototype.peekFront = function () {
        return this.value;
    };
    Single.prototype.peekBack = function () {
        return this.value;
    };
    Single.prototype.moveFront = function (element) {
        return this.contains(element);
    };
    Single.prototype.moveBack = function (element) {
        return this.contains(element);
    };
    Single.prototype.remove = function (element) {
        return this.drop(element) !== value_1.NO_VALUE;
    };
    Single.prototype.valuesFront = function () {
        return this.value === value_1.NO_VALUE ? (0, iterators_1.empty)() : (0, iterators_1.once)(this.value);
    };
    Single.prototype.valuesBack = function () {
        return this.valuesFront();
    };
    Single.prototype.len = function () {
        return Number(this.value !== value_1.NO_VALUE);
    };
    return Single;
}(types_1.IndexedOrderedCollectionWithOrderedKeys));
exports.Single = Single;
//# sourceMappingURL=Single.js.map